"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styles = require("@material-ui/core/styles");

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _reactColor = require("react-color");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {};
        if (obj != null) {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc =
                        Object.defineProperty && Object.getOwnPropertyDescriptor
                            ? Object.getOwnPropertyDescriptor(obj, key)
                            : {};
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}

function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
            return typeof obj;
        };
    } else {
        _typeof = function _typeof(obj) {
            return obj &&
                typeof Symbol === "function" &&
                obj.constructor === Symbol &&
                obj !== Symbol.prototype
                ? "symbol"
                : typeof obj;
        };
    }
    return _typeof(obj);
}

function _extends() {
    _extends =
        Object.assign ||
        function(target) {
            for (var i = 1; i < arguments.length; i++) {
                var source = arguments[i];
                for (var key in source) {
                    if (Object.prototype.hasOwnProperty.call(source, key)) {
                        target[key] = source[key];
                    }
                }
            }
            return target;
        };
    return _extends.apply(this, arguments);
}

function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    _setPrototypeOf(subClass.prototype, superClass && superClass.prototype);
    if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf =
        Object.setPrototypeOf ||
        function _setPrototypeOf(o, p) {
            o.__proto__ = p;
            return o;
        };
    return _setPrototypeOf(o, p);
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}

function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
    _getPrototypeOf =
        Object.getPrototypeOf ||
        function _getPrototypeOf(o) {
            return o.__proto__;
        };
    return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}

var styles = {
    popover: {
        position: "absolute",
        zIndex: 2
    },
    wrapper: {
        position: "fixed",
        top: "0px",
        left: "0px",
        right: "0px",
        bottom: "0px"
    }
};

var ColorPicker =
    /*#__PURE__*/
    (function(_Component) {
        function ColorPicker() {
            var _getPrototypeOf2;

            var _temp, _this;

            _classCallCheck(this, ColorPicker);

            for (
                var _len = arguments.length, args = new Array(_len), _key = 0;
                _key < _len;
                _key++
            ) {
                args[_key] = arguments[_key];
            }

            return _possibleConstructorReturn(
                _this,
                ((_temp = _this = _possibleConstructorReturn(
                    this,
                    (_getPrototypeOf2 = _getPrototypeOf(ColorPicker)).call.apply(
                        _getPrototypeOf2,
                        [this].concat(args)
                    )
                )),
                _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
                    show: false,
                    lastValidInput: ""
                }),
                _defineProperty(
                    _assertThisInitialized(_assertThisInitialized(_this)),
                    "onColorChange",
                    function(color) {
                        _this.setState({
                            lastValidInput: color.hex
                        });

                        _this.props.onChange({
                            target: {
                                value: color.hex
                            }
                        });
                    }
                ),
                _defineProperty(
                    _assertThisInitialized(_assertThisInitialized(_this)),
                    "onInputChange",
                    function(event) {
                        if (event.target.value !== "") {
                            _this.props.onChange({
                                target: {
                                    value: _this.state.lastValidInput
                                }
                            });
                        } else {
                            _this.setState({
                                lastValidInput: ""
                            });

                            _this.props.onChange({
                                target: {
                                    value: ""
                                }
                            });
                        }
                    }
                ),
                _defineProperty(
                    _assertThisInitialized(_assertThisInitialized(_this)),
                    "handleClick",
                    function() {
                        return _this.setState({
                            show: !_this.state.show
                        });
                    }
                ),
                _defineProperty(
                    _assertThisInitialized(_assertThisInitialized(_this)),
                    "handleClose",
                    function() {
                        return _this.setState({
                            show: false
                        });
                    }
                ),
                _temp)
            );
        }

        _createClass(ColorPicker, [
            {
                key: "render",
                value: function render() {
                    var show = this.state.show;

                    var _this$props = this.props,
                        classes = _this$props.classes,
                        value = _this$props.value,
                        onChange = _this$props.onChange,
                        other = _objectWithoutProperties(_this$props, [
                            "classes",
                            "value",
                            "onChange"
                        ]);

                    return _react.default.createElement(
                        "div",
                        null,
                        _react.default.createElement(
                            _TextField.default,
                            _extends(
                                {
                                    value: value,
                                    onClick: this.handleClick,
                                    onChange: this.onInputChange
                                },
                                other
                            )
                        ),
                        show
                            ? _react.default.createElement(
                                  "div",
                                  {
                                      className: classes.popover
                                  },
                                  _react.default.createElement("div", {
                                      className: classes.wrapper,
                                      onClick: this.handleClose
                                  }),
                                  _react.default.createElement(_reactColor.ChromePicker, {
                                      color: value,
                                      disableAlpha: true,
                                      onChange: this.onColorChange
                                  })
                              )
                            : null
                    );
                }
            }
        ]);

        _inherits(ColorPicker, _Component);

        return ColorPicker;
    })(_react.Component);

var _default = (0, _styles.withStyles)(styles)(ColorPicker);

exports.default = _default;
