"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _materialUiPickers = require("material-ui-pickers");

var _ColorPicker = _interopRequireDefault(require("../../ColorPicker/ColorPicker"));

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {};
        if (obj != null) {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc =
                        Object.defineProperty && Object.getOwnPropertyDescriptor
                            ? Object.getOwnPropertyDescriptor(obj, key)
                            : {};
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}

function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
            return typeof obj;
        };
    } else {
        _typeof = function _typeof(obj) {
            return obj &&
                typeof Symbol === "function" &&
                obj.constructor === Symbol &&
                obj !== Symbol.prototype
                ? "symbol"
                : typeof obj;
        };
    }
    return _typeof(obj);
}

function _extends() {
    _extends =
        Object.assign ||
        function(target) {
            for (var i = 1; i < arguments.length; i++) {
                var source = arguments[i];
                for (var key in source) {
                    if (Object.prototype.hasOwnProperty.call(source, key)) {
                        target[key] = source[key];
                    }
                }
            }
            return target;
        };
    return _extends.apply(this, arguments);
}

function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    _setPrototypeOf(subClass.prototype, superClass && superClass.prototype);
    if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf =
        Object.setPrototypeOf ||
        function _setPrototypeOf(o, p) {
            o.__proto__ = p;
            return o;
        };
    return _setPrototypeOf(o, p);
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}

function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assertThisInitialized(self);
}

function _assertThisInitialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}

function _getPrototypeOf(o) {
    _getPrototypeOf =
        Object.getPrototypeOf ||
        function _getPrototypeOf(o) {
            return o.__proto__;
        };
    return _getPrototypeOf(o);
}

/**
 * Component that is used to render all of the forms types.
 *
 * Example:
 * ```jsx
 * <Input formType="input" {...allYourOtherProps} />
 * ```
 */
var Input =
    /*#__PURE__*/
    (function(_Component) {
        function Input() {
            _classCallCheck(this, Input);

            return _possibleConstructorReturn(this, _getPrototypeOf(Input).apply(this, arguments));
        }

        _createClass(Input, [
            {
                key: "render",
                value: function render() {
                    var _this$props = this.props,
                        _this$props$style = _this$props.style,
                        style = _this$props$style === void 0 ? {} : _this$props$style,
                        _this$props$valid = _this$props.valid,
                        valid = _this$props$valid === void 0 ? true : _this$props$valid,
                        _this$props$validatio = _this$props.validation,
                        validation = _this$props$validatio === void 0 ? {} : _this$props$validatio,
                        _this$props$touched = _this$props.touched,
                        touched = _this$props$touched === void 0 ? true : _this$props$touched,
                        formType = _this$props.formType,
                        _this$props$show = _this$props.show,
                        show = _this$props$show === void 0 ? true : _this$props$show,
                        extraProps = _objectWithoutProperties(_this$props, [
                            "style",
                            "valid",
                            "validation",
                            "touched",
                            "formType",
                            "show"
                        ]);

                    var inputElement = null;
                    extraProps.error = !valid && !!validation && touched;
                    extraProps.style = style;

                    switch (formType) {
                        case "input":
                            inputElement = _react.default.createElement(
                                _TextField.default,
                                extraProps
                            );
                            break;

                        case "select":
                            inputElement = _react.default.createElement(
                                _TextField.default,
                                _extends(
                                    {
                                        select: true
                                    },
                                    extraProps
                                ),
                                extraProps.options.map(function(option) {
                                    return _react.default.createElement(
                                        _MenuItem.default,
                                        {
                                            key: option.toLowerCase(),
                                            value: option.toLowerCase()
                                        },
                                        option.charAt(0).toUpperCase() + option.slice(1)
                                    );
                                })
                            );
                            break;

                        case "multiLine":
                            inputElement = _react.default.createElement(
                                _TextField.default,
                                _extends(
                                    {
                                        multiline: true
                                    },
                                    extraProps
                                )
                            );
                            break;

                        case "timePicker":
                            inputElement = _react.default.createElement(
                                "div",
                                null,
                                _react.default.createElement(
                                    _materialUiPickers.TimePicker,
                                    _extends(
                                        {
                                            ampm: false,
                                            showTodayButton: true,
                                            todayLabel: "now"
                                        },
                                        extraProps
                                    )
                                )
                            );
                            break;

                        case "datePicker":
                            inputElement = _react.default.createElement(
                                _materialUiPickers.DatePicker,
                                _extends(
                                    {
                                        showTodayButton: true,
                                        animateYearScrolling: false
                                    },
                                    extraProps
                                )
                            );
                            break;

                        case "colorPicker":
                            inputElement = _react.default.createElement(
                                _ColorPicker.default,
                                extraProps
                            );
                            break;

                        default:
                            inputElement = _react.default.createElement(_TextField.default, null);
                            break;
                    }

                    return _react.default.createElement("div", null, show ? inputElement : null);
                }
            }
        ]);

        _inherits(Input, _Component);

        return Input;
    })(_react.Component);

Input.propTypes = {
    /** Style to be applied to the Input Component */
    style: _propTypes.default.object,

    /** Boolean that says whether the Input is valid */
    valid: _propTypes.default.bool,

    /** Object that gets all the validation */
    validation: _propTypes.default.shape({
        required: _propTypes.default.bool,
        minLength: _propTypes.default.number,
        maxLength: _propTypes.default.number,
        isEmail: _propTypes.default.bool,
        isNumeric: _propTypes.default.bool
    }),

    /** Boolean that says whether the Input Component is already touched or not */
    touched: _propTypes.default.bool,

    /** The type of the Input Component */
    formType: _propTypes.default.oneOf(["input", "select", "multiLine", "timePicker", "datePicker"])
        .isRequired,

    /** Boolean that says whether the Input Component should be shown */
    show: _propTypes.default.bool
};
Input.defaultProps = {
    style: {},
    valid: true,
    validation: {},
    touched: true,
    show: true
};
var _default = Input;
exports.default = _default;
