"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "replaceInArray", {
    enumerable: true,
    get: function get() {
        return _helpers.replaceInArray;
    }
});
Object.defineProperty(exports, "checkValidity", {
    enumerable: true,
    get: function get() {
        return _helpers.checkValidity;
    }
});
Object.defineProperty(exports, "formElementHelper", {
    enumerable: true,
    get: function get() {
        return _helpers.formElementHelper;
    }
});
Object.defineProperty(exports, "changeShow", {
    enumerable: true,
    get: function get() {
        return _helpers.changeShow;
    }
});
Object.defineProperty(exports, "getElementByName", {
    enumerable: true,
    get: function get() {
        return _helpers.getElementByName;
    }
});
Object.defineProperty(exports, "Button", {
    enumerable: true,
    get: function get() {
        return _Button.default;
    }
});
Object.defineProperty(exports, "Input", {
    enumerable: true,
    get: function get() {
        return _Input.default;
    }
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helpers = require("./helpers");

var _MuiPickersUtilsProvider = _interopRequireDefault(
    require("material-ui-pickers/utils/MuiPickersUtilsProvider")
);

var _momentUtils = _interopRequireDefault(require("material-ui-pickers/utils/moment-utils"));

var _Button = _interopRequireDefault(require("./UI/Button/Button"));

var _Input = _interopRequireDefault(require("./UI/Input/Input"));

var _icons = require("@material-ui/icons");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {};
        if (obj != null) {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc =
                        Object.defineProperty && Object.getOwnPropertyDescriptor
                            ? Object.getOwnPropertyDescriptor(obj, key)
                            : {};
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}

function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
            return typeof obj;
        };
    } else {
        _typeof = function _typeof(obj) {
            return obj &&
                typeof Symbol === "function" &&
                obj.constructor === Symbol &&
                obj !== Symbol.prototype
                ? "symbol"
                : typeof obj;
        };
    }
    return _typeof(obj);
}

function _extends() {
    _extends =
        Object.assign ||
        function(target) {
            for (var i = 1; i < arguments.length; i++) {
                var source = arguments[i];
                for (var key in source) {
                    if (Object.prototype.hasOwnProperty.call(source, key)) {
                        target[key] = source[key];
                    }
                }
            }
            return target;
        };
    return _extends.apply(this, arguments);
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(
                Object.getOwnPropertySymbols(source).filter(function(sym) {
                    return Object.getOwnPropertyDescriptor(source, sym).enumerable;
                })
            );
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    _setPrototypeOf(subClass.prototype, superClass && superClass.prototype);
    if (superClass) _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf =
        Object.setPrototypeOf ||
        function _setPrototypeOf(o, p) {
            o.__proto__ = p;
            return o;
        };
    return _setPrototypeOf(o, p);
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}

function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assertThisInitialized(self);
}

function _getPrototypeOf(o) {
    _getPrototypeOf =
        Object.getPrototypeOf ||
        function _getPrototypeOf(o) {
            return o.__proto__;
        };
    return _getPrototypeOf(o);
}

function _assertThisInitialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}

/**
 * Component that generates the form, self-closing
 *
 * Example:
 * ```jsx
 * <Form elements={this.state.form} onChange={this.onChange} onSubmit={this.onSubmit} />
 * ```
 */
var Form =
    /*#__PURE__*/
    (function(_Component) {
        function Form() {
            var _getPrototypeOf2;

            var _temp, _this;

            _classCallCheck(this, Form);

            for (
                var _len = arguments.length, args = new Array(_len), _key = 0;
                _key < _len;
                _key++
            ) {
                args[_key] = arguments[_key];
            }

            return _possibleConstructorReturn(
                _this,
                ((_temp = _this = _possibleConstructorReturn(
                    this,
                    (_getPrototypeOf2 = _getPrototypeOf(Form)).call.apply(
                        _getPrototypeOf2,
                        [this].concat(args)
                    )
                )),
                _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
                    formIsValid: false
                }),
                _defineProperty(
                    _assertThisInitialized(_assertThisInitialized(_this)),
                    "onChange",
                    function(name) {
                        return function(event) {
                            var _this$props = _this.props,
                                elements = _this$props.elements,
                                onChange = _this$props.onChange;
                            var value = event.target ? event.target.value : event;
                            var updatedAddForm = (0, _helpers.replaceInArray)(elements, name, {
                                value: value,
                                touched: true
                            });
                            updatedAddForm = updatedAddForm.map(function(item) {
                                return _objectSpread({}, item, {
                                    valid: (0, _helpers.checkValidity)(item.value, item.validation)
                                });
                            });
                            var formIsValid = updatedAddForm.every(function(item) {
                                return item.show ? item.valid : true;
                            });

                            _this.setState({
                                formIsValid: formIsValid
                            });

                            onChange(updatedAddForm, name, event);
                        };
                    }
                ),
                _temp)
            );
        }

        _createClass(Form, [
            {
                key: "render",
                value: function render() {
                    var _this2 = this;

                    var _this$props2 = this.props,
                        onSubmit = _this$props2.onSubmit,
                        elements = _this$props2.elements,
                        style = _this$props2.style;
                    var formIsValid = this.state.formIsValid;
                    return _react.default.createElement(
                        _MuiPickersUtilsProvider.default,
                        {
                            utils: _momentUtils.default
                        },
                        _react.default.createElement(
                            "form",
                            {
                                onSubmit: onSubmit
                            },
                            elements.map(function(element) {
                                return _react.default.createElement(
                                    _Input.default,
                                    _extends(
                                        {
                                            style: style
                                                ? style
                                                : {
                                                      width: 300,
                                                      margin: 5
                                                  },
                                            key: element.name,
                                            onChange: _this2.onChange(element.name)
                                        },
                                        element
                                    )
                                );
                            }),
                            _react.default.createElement("br", null),
                            _react.default.createElement(
                                _Button.default,
                                {
                                    type: "primary",
                                    submit: true,
                                    disabled: !formIsValid
                                },
                                "Submit \xA0",
                                _react.default.createElement(_icons.Send, null)
                            )
                        )
                    );
                }
            }
        ]);

        _inherits(Form, _Component);

        return Form;
    })(_react.Component);

Form.propTypes = {
    /** Function that is called when the form is submitted */
    onSubmit: _propTypes.default.func.isRequired,

    /** Function that is called when an input in the form changes */
    onChange: _propTypes.default.func.isRequired,

    /** Array of elements that is used by the Component to render the form */
    elements: _propTypes.default.arrayOf(
        _propTypes.default.shape({
            formType: _propTypes.default.oneOf([
                "input",
                "select",
                "multiLine",
                "timePicker",
                "datePicker"
            ]),
            value: _propTypes.default.oneOfType([
                _propTypes.default.string,
                _propTypes.default.instanceOf(Date),
                _propTypes.default.number
            ]),
            validation: _propTypes.default.shape({
                required: _propTypes.default.bool,
                isEmail: _propTypes.default.bool,
                minLength: _propTypes.default.number,
                maxLength: _propTypes.default.number,
                isNumeric: _propTypes.default.bool
            }),
            show: _propTypes.default.bool
        })
    ).isRequired,

    /** Style to be applied to the Input Component */
    style: _propTypes.default.object
};
Form.defaultProps = {
    style: {
        width: 300,
        margin: 5
    }
};
var _default = Form;
exports.default = _default;
